<!DOCTYPE html>
<head>
 <title>D3.js Map Design</title>
 <script src="https://d3js.org/d3.v6.min.js"></script>
</head>
<body>
  <svg></svg>
 <div style=" text-align: center;">
 <div class = "graph" id="svgcontainer"></div>
 <h1>D3.js Bar Chart</h1>
 <div id="svgcontainer">
 </div>

 <script>
//// VARIABLES FOR BAR CHART
   var margin = {top: 20, right: 20, bottom: 50, left:60},
     width   = 600 - margin.left - margin.right,
     height  = 400 - margin.top - margin.bottom,
     x       = d3.scale.ordinal().rangeRoundBands([0,width], 0.5),
     y       = d3.scale.linear().range([height,0]);

//// DRAW AXIS     
   var xAxis = d3.svg.axis()
     .scale(x)
     .orient("bottom");
   var yAxis = d3.svg.axis()
     .scale(y)
     .orient("left")
     .ticks(5)
     .innerTickSize(-width)
     .outerTickSize(0)
     .tickPadding(10);


    /////  CREATE SVG FILE
var svg  = d3.select("#svgcontainer")
  .append("svg")
  .attr("width", width + margin.left + margin.right)
  .attr("height", height + margin.top + margin.bottom)
  .append("g")
  .attr("transform", "translate(" + margin.left + "," + margin.top + ")");
   
   ///// READ DATA FROM JSON FILE
   d3.json("https://yshqzt042e.execute-api.us-east-2.amazonaws.com/DEV", function (data)
     {
         x.domain(data.map(function (d)
         {
             return d.name;
         }));

         y.domain([0, d3.max(data, function (d)
         {
             return d.temperature;
         })]);

      svg.append("g")
          .attr("class", "x axis")
          .attr("transform", "translate(0, " + height + ")")
          .call(xAxis)
          .selectAll("text")
          .style("text-anchor", "middle")
          .attr("dx", "-0.5em")
          .attr("dy", "-.55em")
          .attr("y", 30)
          .attr("transform", "rotate(0)" );

      svg.append("g")
          .attr("class", "y axis")
          .call(yAxis)
          .append("text")
          .attr("transform", "rotate(-90)")
          .attr("y", 5)
          .attr("dy", "0.8em")
          .attr("text-anchor", "end")
          .text("temperature");

      svg.selectAll("bar")
          .data(data)
          .enter()
          .append("rect")
          .style("fill", "blue")
          .attr("x", function(d)
          {
               return x(d.name);
          })
          .attr("width", x.rangeBand())
          .attr("y", function (d)
          {
              return y(d.temperature);
          })
          .attr("height", function(d)
          {
               return height - y(d.temperature);
          });
      
})